

i=7;
for i=1:7
plot(lambda_list,mean(mrr_results(:,:,1,i),2),'-r',...
    lambda_list,mean(mrr_results(:,:,2,i),2),'--r',...
    lambda_list,mean(mrr_results(:,:,3,i),2),'-.r',...
    lambda_list,mean(mrr_results2(:,:,i),2),'b');
pause;
end

%%
i=7;
for i=1:11
semilogx(mean(dof_results(:,:,1,i),2),mean(mrr_results(:,:,1,i),2),'-r',...
    mean(dof_results(:,:,2,i),2),mean(mrr_results(:,:,2,i),2),'--r',...
    mean(dof_results(:,:,3,i),2),mean(mrr_results(:,:,3,i),2),'-.r',...
    mean(dof_results2(:,:,i),2),mean(mrr_results2(:,:,i),2),'b');
pause;
end

%%
i=7;
for i=1:11
    hold off
    errorbar(mean(dof_results(:,:,1,i),2),mean(mcr_results(:,:,1,i),2),std(mcr_results(:,:,1,i),0,2),'-go','linewidth',2);
    hold on
    errorbar(mean(dof_results(:,:,2,i),2),mean(mcr_results(:,:,2,i),2),std(mcr_results(:,:,2,i),0,2),'--co','linewidth',2);
    errorbar(mean(dof_results(:,:,3,i),2),mean(mcr_results(:,:,3,i),2),std(mcr_results(:,:,3,i),0,2),'-.ro','linewidth',2);
    errorbar(mean(dof_results2(:,:,i),2),mean(mcr_results2(:,:,i),2),std(mcr_results2(:,:,i),0,2),'-bx','linewidth',2);
errorbarlogx(0.03)
xlabel('d.o.f.')
ylabel('Misclassification rate')
legend('.GTF k=0', 'GTF k=1', 'GTF k=2','Laplacian','location','best')
%grid on
pause;
end

%%
i=7;
for i=1:11
    hold off
    errorbar(mean(dof_results(:,1:11,1,i),2),mean(mrr_results(:,1:11,1,i),2),std(mcr_results(:,1:11,1,i),0,2),'-go','linewidth',2);
    hold on
    errorbar(mean(dof_results(:,1:11,2,i),2),mean(mrr_results(:,1:11,2,i),2),std(mcr_results(:,1:11,2,i),0,2),'--co','linewidth',2);
    errorbar(mean(dof_results(:,1:11,3,i),2),mean(mrr_results(:,1:11,3,i),2),std(mcr_results(:,1:11,3,i),0,2),'-.ro','linewidth',2);
    errorbar(mean(dof_results2(:,1:11,i),2),mean(mrr_results2(:,1:11,i),2),std(mcr_results2(:,1:11,i),0,2),'-bx','linewidth',2);
errorbarlogx(0.03)
xlabel('d.o.f.')
ylabel('Mean Reciprocal Rank')
legend('.GTF k=0', 'GTF k=1', 'GTF k=2','Laplacian','location','best')
%grid on
pause;
end

%% Paired t-test
didx =[1,9,3,4,5,6,7,8,10,11,2];%according to the ordering on the UCI website. 

for i=1:11
    mm1=mean(mcr_results(:,:,1,didx(i)),2);
    mm2=mean(mcr_results(:,:,2,didx(i)),2);
    mm3=mean(mcr_results(:,:,3,didx(i)),2);
    mm4=mean(mcr_results2(:,:,didx(i)),2);
    
    [tmp1,idx1]=min(mm1);
    [tmp2,idx2]=min(mm2);
    [tmp3,idx3]=min(mm3);
    [tmp4,idx4]=min(mm4);
    
    ss1=mcr_results(idx1,:,1,didx(i));
    ss2=mcr_results(idx2,:,2,didx(i));
    ss3=mcr_results(idx3,:,3,didx(i));
    ss4=mcr_results2(idx4,:,didx(i));
    
    [h1,p1 ]= ttest(ss1,ss4);
    [h2,p2 ]= ttest(ss2,ss4);
    [h3,p3 ]= ttest(ss3,ss4);
    
    
    fprintf('Dataset %d: m=[%.3f,%.3f,%.3f,%.3f] h=[%d,%d,%d]. p=[%.3f,%.3f,%.3f]\n',i,tmp4,tmp1,tmp2,tmp3,h1,h2,h3,p1,p2,p3);
end

%%
didx =[1,9,3,4,5,6,7,8,10,11,2];%according to the ordering on the UCI website. 

for i=1:11
    mm1=mean(mrr_results(:,:,1,i),2);
    mm2=mean(mrr_results(:,:,2,i),2);
    mm3=mean(mrr_results(:,:,3,i),2);
    mm4=mean(mrr_results2(:,:,i),2);
    
    [tmp1,idx1]=max(mm1);
    [tmp2,idx2]=max(mm2);
    [tmp3,idx3]=max(mm3);
    [tmp4,idx4]=max(mm4);
    
    ss1=mrr_results(idx1,:,1,i);
    ss2=mrr_results(idx2,:,2,i);
    ss3=mrr_results(idx3,:,3,i);
    ss4=mrr_results2(idx4,:,i);
    
    [h1,p1 ]= ttest(ss1,ss4);
    [h2,p2 ]= ttest(ss2,ss4);
    [h3,p3 ]= ttest(ss3,ss4);
    
    
    fprintf('Dataset %d: m=[%f,%f,%f] h=[%d,%d,%d]. p=[%f,%f,%f]\n',i,tmp4-tmp1,tmp4-tmp2,tmp4-tmp3,h1,h2,h3,p1,p2,p3);
end


%% Plot Improvement MCR
didx =[1,9,3,4,5,6,7,8,10,11,2];%according to the ordering on the UCI website. 

ratio=zeros(4,11);

for i=1:11
    
    mm1=mean(mcr_results(:,:,1,didx(i)),2);
    mm2=mean(mcr_results(:,:,2,didx(i)),2);
    mm3=mean(mcr_results(:,:,3,didx(i)),2);
    mm4=mean(mcr_results2(:,:,didx(i)),2);
    
    [tmp1,idx1]=min(mm1);
    [tmp2,idx2]=min(mm2);
    [tmp3,idx3]=min(mm3);
    [tmp4,idx4]=min(mm4);
    
    ss1=mcr_results(idx1,:,1,didx(i));
    ss2=mcr_results(idx2,:,2,didx(i));
    ss3=mcr_results(idx3,:,3,didx(i));
    ss4=mcr_results2(idx4,:,didx(i));
    
    
%     ratio(1,i)=mean(ss4./ss1);
%     ratio(2,i)=mean(ss4./ss2);
%     ratio(3,i)=mean(ss4./ss3);
%     ratio(4,i)=mean(ss4./ss4);
    
    
    ratio(1,i)=tmp1/tmp4;
    ratio(2,i)=tmp2/tmp4;
    ratio(3,i)=tmp3/tmp4;
    ratio(4,i)=tmp4/tmp4;
end

% hold off;
% plot(ratio(1:3,:)','x','linewidth',2,'markersize',15)
% lg=legend('k=0','k=1','k=2')
% set(lg,'fontsize',14)
% hold on;
% plot(1:6,ones(6),'k-','linewidth',2)
% 
% ylim([0.95,1.2])
% xlabel('Datasets','fontsize',14)
% ylabel('Improvement over MAD on UCI datasets','fontsize',14)



fileID = fopen('datasetNames1.txt');
datanames=textscan(fileID,'%s');
fclose(fileID);
datanames=datanames{1};
datanames{8}='poker-hand';
datanames{5}='breast-cancer';
datanames{11}='internet-ads';

hfig=figure(1)
hold off;
plot(1:11,ratio(1,:)','sg',...
1:11,ratio(2,:)','xr',...
    1:11,ratio(3,:)','ob','linewidth',2,'markersize',12)


hold on;
plot(0:12,ones(13,1),'k-','linewidth',2)
lg=legend('MAD-GTF k=0','MAD-GTF k=1','MAD-GTF k=2','MAD-Laplacian')
set(lg,'fontsize',12,'location','north')
ylabel('MCR Ratio: MAD-GTF / MAD-Laplacian','fontsize',13)
set(gca,'XTick',1:11,'XTickLabel',datanames(didx),'fontsize',13)
rotateXLabels( gca(), 30)

xlim([0.5,11.5])
ylim([0.65,1.3])
grid on
set(hfig,'position',[100,100,600,400])

ax = get(hfig, 'CurrentAxes');

% make it tight
ti = get(ax,'TightInset');
set(ax,'Position',[ti(1) ti(2)+0.2 1-(ti(3)+ti(1))*1.1 1-(ti(4)+ti(2))-0.17]);

% adjust the papersize
set(ax,'units','centimeters');
pos = get(ax,'Position');
ti = get(ax,'TightInset');
set(hfig, 'PaperUnits','centimeters');
set(hfig, 'PaperSize', [pos(3)+ti(1)+ti(3) pos(4)+ti(2)+ti(4)]);
set(hfig, 'PaperPositionMode', 'manual');
set(hfig, 'PaperPosition',[0 0  pos(3)+ti(1)+ti(3) pos(4)+ti(2)+ti(4)]);

% save it
saveas(hfig,'UCI_RatioPlot.pdf');


%saveTightFigure(hfig,'UCI_RatioPlot.pdf')


