%% Generate knn graph for every dataset
% get list of names for data
fileID = fopen('datasetNames1.txt');
datanames=textscan(fileID,'%s');
fclose(fileID);
datanames=datanames{1};
numdata=length(datanames);


%% Preprocess the data to find the graph
% define distance function

for di = numdata
    tic
    load([datanames{di},'/data.mat']);
    true_labels=data(:,end);
    X=data(:,1:end-1);
    [n,p]=size(X);
    
    K=5;
    NS = createns(X,'NSMethod','kdtree');
    [IDX,D] = knnsearch(NS,X,'K',K+1);
    ii=kron(ones(K+1,1),(1:n)');
    jj=IDX(:);
    ix=ii==jj;
    A = sparse(ii(~ix),jj(~ix),ones(length(ii(~ix)),1),n,n);
    [edges1,edges2, w]=find(A);
    fprintf('Graph constructed in %f seconds.\n',toc);
    
    save([datanames{di},'/graph.mat'],'edges1','edges2','w');
    
end
