%% Script to clean and preprocess the data

cd iris 
load iris1.data
X=iris1(:,1:4); % feature
Y=iris1(:,5)+1; % label
X=zscore(X);

data=[X,Y];
save('data.mat','data')


%% Poker-Hand-Data
cd ../poker
ZZ=load('poker-hand-training-true.data');
X=ZZ(:,1:end-1); % feature
Y=ZZ(:,end)+1; % label

Dict=zeros(size(ZZ,1),52);
% for j=1:5
%     Dict(:,13*(X(:,j*2-1)-1)+X(:,j*2))=Dict(:,13*(X(:,j*2-1)-1)+X(:,j*2))+1;
% end


for i=1:size(ZZ,1)
    for j=1:5
        Dict(i,13*(X(i,j*2-1)-1)+X(i,j*2))=Dict(i,13*(X(i,j*2-1)-1)+X(i,j*2))+1;
    end
end
Y=Y+1;
% subsample

nn=length(Y);
n=3000;
idx = randsample(nn,n);


data=[Dict(idx,:),Y(idx)];
save('data.mat','data')

%% Abalone data set
cd ../abalone
ZZ=load('abalone1.data');
X=ZZ(:,1:end-1); % feature
Y=ZZ(:,end)-min(ZZ(:,end))+1; % label

Z=zeros(size(X,1),size(X,2));
% coding the gender,  Male Female and Infant
Z(:,3:end)=X(:,2:end-1);
Z(X(:,1)==1,1)=1;Z(X(:,1)==1,2)=0;
Z(X(:,1)==2,1)=-1;Z(X(:,1)==2,2)=0;
Z(X(:,1)==3,1)=0;Z(X(:,1)==3,2)=1;

Z=zscore(Z);

data=[Z,Y];
save('data.mat','data')

%% Wisconsin Breast Cancer
cd ../breast-cancer-wisconsin
ZZ=load('wdbc1.data');
X=ZZ(:,3:end); % feature
Y=ZZ(:,2); % label

X=zscore(X);

data=[X,Y];
save('data.mat','data')

%% Wine
cd ../wine
ZZ=load('wine.data');
X=ZZ(:,2:end); % feature
Y=ZZ(:,1); % label

X=zscore(X);

data=[X,Y];
save('data.mat','data')

%% Wine-quality white
cd ../wine-quality

ZZ = dlmread('winequality-red.csv',';',1,0);
X=ZZ(:,1:end-1); % feature
Y=ZZ(:,end)-min(ZZ(:,end))+1; % label

X=zscore(X);

data=[X,Y];
save('data.mat','data')

%% Yeast 
cd ../yeast

ZZ = dlmread('yeast1.data',',',0,1);
X=ZZ(:,1:end-1); % feature
Y=ZZ(:,end)-min(ZZ(:,end))+1; % label

X=zscore(X);

data=[X,Y];
save('data.mat','data')

%% Adult
cd ../adult

fileID = fopen('adult1.data');
ZZ = textscan(fileID,'%d, %s %d, %s %d, %s %s %s %s %s %d, %d, %d, %s %d');
fclose(fileID);

Y=double(ZZ{15});%label
X=double([ZZ{1},ZZ{3},ZZ{5},ZZ{11},ZZ{12},ZZ{13}]);%numerical features
XX=dummyvar({ZZ{2},ZZ{4},ZZ{6},ZZ{7},ZZ{8},ZZ{9},ZZ{10},ZZ{14}});%Categorical features

X=zscore(X);
data=[XX,X,Y];

save('data.mat','data')

%% Car
cd ../car

fileID = fopen('car1.data');
ZZ = textscan(fileID,'%s %s %s %s %s %s %d');
fclose(fileID);

Y=double(ZZ{7});%label
XX=dummyvar({ZZ{1:6}});%Categorical features

data=[XX,Y];

save('data.mat','data')


%% heart-disease
cd ../heart-disease

fileID = fopen('datasets-uci-heart-c.csv');
ZZ = textscan(fileID,'%d, %s %s %d, %d, %s %s %d, %s %d, %s %d, %s %d');
fclose(fileID);

%X=ZZ(:,1:end-1); % feature
%Y=ZZ(:,end)-min(ZZ(:,end))+1; % label
%ZZ = textscan(fileID,'%s %s %s %s %s %s %d');
%fclose(fileID);

Y=double(ZZ{14});%label
X=double([ZZ{1},ZZ{4},ZZ{5},ZZ{8},ZZ{10},ZZ{12}]);%numerical features
XX=dummyvar({ZZ{2},ZZ{3},ZZ{6},ZZ{7},ZZ{9},ZZ{11},ZZ{13}});%Categorical features

X=zscore(X);
data=[XX,X,Y];

save('data.mat','data')



%% internet-ads
cd ../internet_ads

ZZ=csvread('ad.data');
X=ZZ(:,1:end-1); % feature
Y=ZZ(:,end)-min(ZZ(:,end))+1; % label

%first 3 are continuous, everything else is 0,1

X(X==-1)=0;%zero fill the missing data
X(:,1:3)=zscore(X(:,1:3));
data=[X,Y];
save('data.mat','data')
